#include "Box.h"
#include <stdio.h>
#include <glm/glm.hpp>

using namespace glm;

Box::Box(vec3 &corner, float x, float y, float z) {

	setBox(corner, x, y, z);
}

Box::Box(void) {
	corner.x = 0; corner.y = 0; corner.z = 0;
	x = 1.0f;
	y = 1.0f;
	z = 1.0f;
}
Box::~Box() {}

void Box::setBox(vec3 &corner, float x, float y, float z) {
	this->corner = corner;

	if (x < 0.0) {
		x = -x;
		this->corner.x -= x;
	}
	if (y < 0.0) {
		y = -y;
		this->corner.y -= y;
	}
	if (z < 0.0) {
		z = -z;
		this->corner.z -= z;
	}
	this->x = x;
	this->y = y;
	this->z = z;
}

vec3 Box::getVertexP(vec3 &normal) {

	vec3 res = corner;

	if (normal.x > 0)
		res.x += x;

	if (normal.y > 0)
		res.y += y;

	if (normal.z > 0)
		res.z += z;

	return(res);
}



vec3 Box::getVertexN(vec3 &normal) {

	vec3 res = corner;

	if (normal.x < 0)
		res.x += x;

	if (normal.y < 0)
		res.y += y;

	if (normal.z < 0)
		res.z += z;

	return(res);
}