#ifndef FLARE_MANAGER_H
#define FLARE_MANAGER_H
#include <vector>

#include "Camera.h"

#include "FlareTexture.h"
#include "FlareRenderer.h"

class FlareManager
{
public:
	// Constructor
	FlareManager(GLfloat spacing, Shader shader, GLuint screenW, GLuint screenH, FlareTexture flares[], GLfloat amount);
	// Render flare
	void FlareManager::render(glm::mat4 view, glm::mat4 projection, glm::vec3 lightPosition);

private:
	GLfloat amount;
	GLfloat spacing;
	std::vector<FlareTexture> flares;
	FlareRenderer renderer;

	// Initializes buffer and vertex attributes
	void init(FlareTexture flares[]);
	void FlareManager::calcFlarePositions(glm::vec2 sunToCenter, glm::vec2 sunCoords);
	glm::vec2 FlareManager::convertToScreenSpace(glm::vec3 lightPosition, glm::mat4 view, glm::mat4 projection);
};


#endif