#ifndef FLARE_RENDERER_H
#define FLARE_RENDERER_H
#include <vector>

#include <GL/glew.h>
#include <glm/glm.hpp>

#include "shader.h"
#include "FlareTexture.h"

class FlareRenderer
{
public:
	// Constructor
	FlareRenderer(Shader shader, GLuint screenWidth, GLuint screenHeight);
	// Render flare
	void Draw(std::vector<FlareTexture> flares, GLfloat brightness);
private:
	// Render state
	Shader shader;
	// screen sizes
	GLuint screenWidth, screenHeight;

	GLuint VAO;
	// Initializes buffer and vertex attributes
	void init();
};

#endif

