#version 330 core
out vec4 FragColor;

in vec2 TexCoords;

uniform sampler2D scene;
uniform sampler2D bloomBlur;
uniform bool bloom;

void main()
{             
	//float exposure = 2.0f;
	//float A = 0.25f; float B = 0.50f; float C = 0.10f;
	//float D = 0.20f; float E = 0.02f; float F = 0.30f; float W = 11.2f;

    vec3 color = texture(scene, TexCoords).rgb;      
    vec3 bloomColor = texture(bloomBlur, TexCoords).rgb;
    if(bloom)
        color += bloomColor; // additive blending


	// Uncharted2 tonemapping
	//vec3 tonemappedVec = exposure * (((color*(A*color+C*B)+D*E)/(color*(A*color+B)+D*F))-E*F);
	//float whiteScale = 1.0f / (((W*(A*W+C*B)+D*E)/(W*(A*W+B)+D*F))-E*F);
	//vec3 result = tonemappedVec * whiteScale;

    FragColor = vec4(color, 1.0);
}